/* NodeGroup.c generated by valac 0.48.13, the Vala compiler
 * generated from NodeGroup.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <string.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <libxml/tree.h>
#include <gee.h>
#include <stdlib.h>
#include <cairo-gobject.h>
#include <gobject/gvaluecollector.h>

#define TYPE_NODE_POINT (node_point_get_type ())
typedef struct _NodePoint NodePoint;
typedef enum  {
	GROUP_MODE_NONE = 0,
	GROUP_MODE_SELECTED
} GroupMode;

#define TYPE_GROUP_MODE (group_mode_get_type ())

#define TYPE_NODE_GROUP (node_group_get_type ())
#define NODE_GROUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE_GROUP, NodeGroup))
#define NODE_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE_GROUP, NodeGroupClass))
#define IS_NODE_GROUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE_GROUP))
#define IS_NODE_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE_GROUP))
#define NODE_GROUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE_GROUP, NodeGroupClass))

typedef struct _NodeGroup NodeGroup;
typedef struct _NodeGroupClass NodeGroupClass;
typedef struct _NodeGroupPrivate NodeGroupPrivate;

#define TYPE_NODE (node_get_type ())
#define NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE, Node))
#define NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE, NodeClass))
#define IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE))
#define IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE))
#define NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE, NodeClass))

typedef struct _Node Node;
typedef struct _NodeClass NodeClass;
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_THEME (theme_get_type ())
#define THEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME, Theme))
#define THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME, ThemeClass))
#define IS_THEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME))
#define IS_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME))
#define THEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME, ThemeClass))

typedef struct _Theme Theme;
typedef struct _ThemeClass ThemeClass;
#define __vala_GdkRGBA_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkRGBA_free (var), NULL)))
typedef enum  {
	NODE_SIDE_LEFT = 1,
	NODE_SIDE_TOP = 2,
	NODE_SIDE_RIGHT = 4,
	NODE_SIDE_BOTTOM = 8
} NodeSide;

#define TYPE_NODE_SIDE (node_side_get_type ())
typedef struct _ParamSpecNodeGroup ParamSpecNodeGroup;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _NodePoint {
	gdouble x;
	gdouble y;
};

struct _NodeGroup {
	GTypeInstance parent_instance;
	volatile int ref_count;
	NodeGroupPrivate * priv;
};

struct _NodeGroupClass {
	GTypeClass parent_class;
	void (*finalize) (NodeGroup *self);
};

struct _NodeGroupPrivate {
	GArray* _nodes;
	GroupMode _mode;
	GdkRGBA _color;
};

struct _ParamSpecNodeGroup {
	GParamSpec parent_instance;
};

static gint NodeGroup_private_offset;
static gpointer node_group_parent_class = NULL;

GType node_point_get_type (void) G_GNUC_CONST;
NodePoint* node_point_dup (const NodePoint* self);
void node_point_free (NodePoint* self);
void node_point_init (NodePoint *self,
                      gdouble x,
                      gdouble y);
GType group_mode_get_type (void) G_GNUC_CONST;
gpointer node_group_ref (gpointer instance);
void node_group_unref (gpointer instance);
GParamSpec* param_spec_node_group (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
void value_set_node_group (GValue* value,
                           gpointer v_object);
void value_take_node_group (GValue* value,
                            gpointer v_object);
gpointer value_get_node_group (const GValue* value);
GType node_group_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NodeGroup, node_group_unref)
GType node_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Node, g_object_unref)
GType draw_area_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DrawArea, g_object_unref)
NodeGroup* node_group_new (DrawArea* da,
                           Node* node);
NodeGroup* node_group_construct (GType object_type,
                                 DrawArea* da,
                                 Node* node);
void node_get_link_color (Node* self,
                          GdkRGBA * result);
void node_group_set_color (NodeGroup* self,
                           GdkRGBA * value);
static void _g_object_unref0_ (gpointer var);
static void _vala_Node_free_function_content_of (gpointer data);
void node_group_add_node (NodeGroup* self,
                          Node* node);
NodeGroup* node_group_new_array (DrawArea* da,
                                 GArray* nodes);
NodeGroup* node_group_construct_array (GType object_type,
                                       DrawArea* da,
                                       GArray* nodes);
NodeGroup* node_group_new_copy (NodeGroup* group);
NodeGroup* node_group_construct_copy (GType object_type,
                                      NodeGroup* group);
void node_group_get_color (NodeGroup* self,
                           GdkRGBA * result);
NodeGroup* node_group_new_from_xml (DrawArea* da,
                                    xmlNode* n,
                                    GeeHashMap* id_map);
NodeGroup* node_group_construct_from_xml (GType object_type,
                                          DrawArea* da,
                                          xmlNode* n,
                                          GeeHashMap* id_map);
void node_group_load (NodeGroup* self,
                      DrawArea* da,
                      xmlNode* g,
                      GeeHashMap* id_map);
gboolean node_is_descendant_of (Node* self,
                                Node* node);
void node_set_group (Node* self,
                     gboolean value);
gboolean node_group_remove_node (NodeGroup* self,
                                 Node* node);
void node_group_merge (NodeGroup* self,
                       NodeGroup* other);
gboolean node_group_is_within (NodeGroup* self,
                               gdouble x,
                               gdouble y);
static void _node_point_free0_ (gpointer var);
static void _vala_NodePoint_free_function_content_of (gpointer data);
void node_group_get_tree_points (Node* origin,
                                 Node* node,
                                 GArray* points);
void node_group_get_convex_hull (GArray* points,
                                 GArray* hull);
xmlNode* node_group_save (NodeGroup* self);
gchar* utils_color_from_rgba (GdkRGBA* rgba);
gint node_id (Node* self);
static void node_group_load_node (NodeGroup* self,
                           DrawArea* da,
                           xmlNode* n,
                           GeeHashMap* id_map);
Node* draw_area_get_node (DrawArea* self,
                          GArray* nodes,
                          gint id);
GArray* draw_area_get_nodes (DrawArea* self);
GType theme_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Theme, g_object_unref)
void node_group_draw (NodeGroup* self,
                      cairo_t* ctx,
                      Theme* theme);
GroupMode node_group_get_mode (NodeGroup* self);
gdouble node_get_alpha (Node* self);
GdkRGBA* theme_get_color (Theme* self,
                          const gchar* name);
static void _vala_GdkRGBA_free (GdkRGBA* self);
static GdkRGBA* _vala_GdkRGBA_copy (GdkRGBA* self);
static void node_group_draw_cloud (cairo_t* ctx,
                            GdkRGBA* color,
                            gboolean selected,
                            gdouble alpha,
                            GArray* points);
void node_group_draw_tree (cairo_t* ctx,
                           Node* node,
                           Theme* theme);
void utils_set_context_color_with_alpha (cairo_t* ctx,
                                         GdkRGBA* color,
                                         gdouble alpha);
void node_group_add_node_points (GArray* points,
                                 Node* node,
                                 gint pad);
gdouble node_get_posx (Node* self);
gdouble node_get_posy (Node* self);
gdouble node_get_width (Node* self);
gdouble node_get_height (Node* self);
gboolean node_get_folded (Node* self);
void node_fold_bbox (Node* self,
                     gdouble* x,
                     gdouble* y,
                     gdouble* w,
                     gdouble* h);
GType node_side_get_type (void) G_GNUC_CONST;
NodeSide node_get_side (Node* self);
Node* node_folded_ancestor (Node* self);
gint node_groups_between (Node* self,
                          Node* node);
GArray* node_children (Node* self);
gint node_group_calc_orientation (NodePoint* p,
                                  NodePoint* q,
                                  NodePoint* r);
void node_group_set_mode (NodeGroup* self,
                          GroupMode value);
GArray* node_group_get_nodes (NodeGroup* self);
static void node_group_finalize (NodeGroup * obj);
static GType node_group_get_type_once (void);

void
node_point_init (NodePoint *self,
                 gdouble x,
                 gdouble y)
{
	memset (self, 0, sizeof (NodePoint));
	(*self).x = x;
	(*self).y = y;
}

NodePoint*
node_point_dup (const NodePoint* self)
{
	NodePoint* dup;
	dup = g_new0 (NodePoint, 1);
	memcpy (dup, self, sizeof (NodePoint));
	return dup;
}

void
node_point_free (NodePoint* self)
{
	g_free (self);
}

static GType
node_point_get_type_once (void)
{
	GType node_point_type_id;
	node_point_type_id = g_boxed_type_register_static ("NodePoint", (GBoxedCopyFunc) node_point_dup, (GBoxedFreeFunc) node_point_free);
	return node_point_type_id;
}

GType
node_point_get_type (void)
{
	static volatile gsize node_point_type_id__volatile = 0;
	if (g_once_init_enter (&node_point_type_id__volatile)) {
		GType node_point_type_id;
		node_point_type_id = node_point_get_type_once ();
		g_once_init_leave (&node_point_type_id__volatile, node_point_type_id);
	}
	return node_point_type_id__volatile;
}

static GType
group_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{GROUP_MODE_NONE, "GROUP_MODE_NONE", "none"}, {GROUP_MODE_SELECTED, "GROUP_MODE_SELECTED", "selected"}, {0, NULL, NULL}};
	GType group_mode_type_id;
	group_mode_type_id = g_enum_register_static ("GroupMode", values);
	return group_mode_type_id;
}

GType
group_mode_get_type (void)
{
	static volatile gsize group_mode_type_id__volatile = 0;
	if (g_once_init_enter (&group_mode_type_id__volatile)) {
		GType group_mode_type_id;
		group_mode_type_id = group_mode_get_type_once ();
		g_once_init_leave (&group_mode_type_id__volatile, group_mode_type_id);
	}
	return group_mode_type_id__volatile;
}

static inline gpointer
node_group_get_instance_private (NodeGroup* self)
{
	return G_STRUCT_MEMBER_P (self, NodeGroup_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static void
_vala_Node_free_function_content_of (gpointer data)
{
	Node* self;
	self = *((Node**) data);
	_g_object_unref0_ (self);
}

NodeGroup*
node_group_construct (GType object_type,
                      DrawArea* da,
                      Node* node)
{
	NodeGroup* self = NULL;
	GdkRGBA _tmp0_ = {0};
	GdkRGBA _tmp1_;
	GArray* _tmp2_;
	g_return_val_if_fail (da != NULL, NULL);
	g_return_val_if_fail (node != NULL, NULL);
	self = (NodeGroup*) g_type_create_instance (object_type);
	node_get_link_color (node, &_tmp0_);
	_tmp1_ = _tmp0_;
	node_group_set_color (self, &_tmp1_);
	_tmp2_ = g_array_new (TRUE, TRUE, sizeof (Node*));
	g_array_set_clear_func (_tmp2_, (GDestroyNotify) _vala_Node_free_function_content_of);
	_g_array_unref0 (self->priv->_nodes);
	self->priv->_nodes = _tmp2_;
	node_group_add_node (self, node);
	return self;
}

NodeGroup*
node_group_new (DrawArea* da,
                Node* node)
{
	return node_group_construct (TYPE_NODE_GROUP, da, node);
}

NodeGroup*
node_group_construct_array (GType object_type,
                            DrawArea* da,
                            GArray* nodes)
{
	NodeGroup* self = NULL;
	Node* _tmp0_;
	GdkRGBA _tmp1_ = {0};
	GdkRGBA _tmp2_;
	GArray* _tmp3_;
	g_return_val_if_fail (da != NULL, NULL);
	g_return_val_if_fail (nodes != NULL, NULL);
	self = (NodeGroup*) g_type_create_instance (object_type);
	_tmp0_ = g_array_index (nodes, Node*, (guint) 0);
	node_get_link_color (_tmp0_, &_tmp1_);
	_tmp2_ = _tmp1_;
	node_group_set_color (self, &_tmp2_);
	_tmp3_ = g_array_new (TRUE, TRUE, sizeof (Node*));
	g_array_set_clear_func (_tmp3_, (GDestroyNotify) _vala_Node_free_function_content_of);
	_g_array_unref0 (self->priv->_nodes);
	self->priv->_nodes = _tmp3_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				Node* _tmp6_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				if (!(((guint) i) < nodes->len)) {
					break;
				}
				_tmp6_ = g_array_index (nodes, Node*, (guint) i);
				node_group_add_node (self, _tmp6_);
			}
		}
	}
	return self;
}

NodeGroup*
node_group_new_array (DrawArea* da,
                      GArray* nodes)
{
	return node_group_construct_array (TYPE_NODE_GROUP, da, nodes);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

NodeGroup*
node_group_construct_copy (GType object_type,
                           NodeGroup* group)
{
	NodeGroup* self = NULL;
	GdkRGBA _tmp0_;
	GArray* _tmp1_;
	g_return_val_if_fail (group != NULL, NULL);
	self = (NodeGroup*) g_type_create_instance (object_type);
	_tmp0_ = group->priv->_color;
	node_group_set_color (self, &_tmp0_);
	_tmp1_ = g_array_new (TRUE, TRUE, sizeof (Node*));
	g_array_set_clear_func (_tmp1_, (GDestroyNotify) _vala_Node_free_function_content_of);
	_g_array_unref0 (self->priv->_nodes);
	self->priv->_nodes = _tmp1_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				GArray* _tmp4_;
				GArray* _tmp5_;
				GArray* _tmp6_;
				Node* _tmp7_;
				Node* _tmp8_;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = i;
					i = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				_tmp4_ = group->priv->_nodes;
				if (!(((guint) i) < _tmp4_->len)) {
					break;
				}
				_tmp5_ = self->priv->_nodes;
				_tmp6_ = group->priv->_nodes;
				_tmp7_ = g_array_index (_tmp6_, Node*, (guint) i);
				_tmp8_ = _g_object_ref0 (_tmp7_);
				g_array_append_val (_tmp5_, _tmp8_);
			}
		}
	}
	return self;
}

NodeGroup*
node_group_new_copy (NodeGroup* group)
{
	return node_group_construct_copy (TYPE_NODE_GROUP, group);
}

NodeGroup*
node_group_construct_from_xml (GType object_type,
                               DrawArea* da,
                               xmlNode* n,
                               GeeHashMap* id_map)
{
	NodeGroup* self = NULL;
	GArray* _tmp0_;
	g_return_val_if_fail (da != NULL, NULL);
	g_return_val_if_fail (id_map != NULL, NULL);
	self = (NodeGroup*) g_type_create_instance (object_type);
	_tmp0_ = g_array_new (TRUE, TRUE, sizeof (Node*));
	g_array_set_clear_func (_tmp0_, (GDestroyNotify) _vala_Node_free_function_content_of);
	_g_array_unref0 (self->priv->_nodes);
	self->priv->_nodes = _tmp0_;
	node_group_load (self, da, n, id_map);
	return self;
}

NodeGroup*
node_group_new_from_xml (DrawArea* da,
                         xmlNode* n,
                         GeeHashMap* id_map)
{
	return node_group_construct_from_xml (TYPE_NODE_GROUP, da, n, id_map);
}

static gpointer
vala_g_array_remove_index (GArray* self,
                           guint index)
{
	gpointer g = NULL;
	gpointer* _tmp0_;
	gint _tmp0__length1;
	gpointer _tmp1_;
	gpointer result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_vala_assert (self->len > index, "length > index");
	_tmp0_ = self->data;
	_tmp0__length1 = self->len;
	_tmp1_ = _tmp0_[index];
	_tmp0_[index] = NULL;
	g = _tmp1_;
	g_array_remove_index (self, index);
	result = g;
	return result;
}

void
node_group_add_node (NodeGroup* self,
                     Node* node)
{
	GArray* _tmp13_;
	Node* _tmp14_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (node != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GArray* _tmp2_;
				Node* n = NULL;
				GArray* _tmp3_;
				Node* _tmp4_;
				Node* _tmp5_;
				Node* _tmp6_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->priv->_nodes;
				if (!(((guint) i) < _tmp2_->len)) {
					break;
				}
				_tmp3_ = self->priv->_nodes;
				_tmp4_ = g_array_index (_tmp3_, Node*, (guint) i);
				_tmp5_ = _g_object_ref0 (_tmp4_);
				n = _tmp5_;
				_tmp6_ = n;
				if (node_is_descendant_of (_tmp6_, node)) {
					GArray* _tmp7_;
					Node* _tmp8_;
					GArray* _tmp9_;
					Node* _tmp10_;
					Node* _tmp11_;
					_tmp7_ = self->priv->_nodes;
					_tmp8_ = g_array_index (_tmp7_, Node*, (guint) i);
					node_set_group (_tmp8_, FALSE);
					_tmp9_ = self->priv->_nodes;
					_tmp10_ = vala_g_array_remove_index (_tmp9_, (guint) i);
					_tmp11_ = _tmp10_;
					_g_object_unref0 (_tmp11_);
				} else {
					Node* _tmp12_;
					_tmp12_ = n;
					if (node_is_descendant_of (node, _tmp12_)) {
						_g_object_unref0 (n);
						return;
					}
				}
				_g_object_unref0 (n);
			}
		}
	}
	node_set_group (node, TRUE);
	_tmp13_ = self->priv->_nodes;
	_tmp14_ = _g_object_ref0 (node);
	g_array_append_val (_tmp13_, _tmp14_);
}

gboolean
node_group_remove_node (NodeGroup* self,
                        Node* node)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (node != NULL, FALSE);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GArray* _tmp2_;
				GArray* _tmp3_;
				Node* _tmp4_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->priv->_nodes;
				if (!(((guint) i) < _tmp2_->len)) {
					break;
				}
				_tmp3_ = self->priv->_nodes;
				_tmp4_ = g_array_index (_tmp3_, Node*, (guint) i);
				if (_tmp4_ == node) {
					GArray* _tmp5_;
					Node* _tmp6_;
					Node* _tmp7_;
					node_set_group (node, FALSE);
					_tmp5_ = self->priv->_nodes;
					_tmp6_ = vala_g_array_remove_index (_tmp5_, (guint) i);
					_tmp7_ = _tmp6_;
					_g_object_unref0 (_tmp7_);
					result = TRUE;
					return result;
				}
			}
		}
	}
	result = FALSE;
	return result;
}

void
node_group_merge (NodeGroup* self,
                  NodeGroup* other)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (other != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GArray* _tmp2_;
				GArray* _tmp3_;
				Node* _tmp4_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = other->priv->_nodes;
				if (!(((guint) i) < _tmp2_->len)) {
					break;
				}
				_tmp3_ = other->priv->_nodes;
				_tmp4_ = g_array_index (_tmp3_, Node*, (guint) i);
				node_group_add_node (self, _tmp4_);
			}
		}
	}
}

static void
_node_point_free0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (node_point_free (var), NULL));
}

static void
_vala_NodePoint_free_function_content_of (gpointer data)
{
	NodePoint* self;
	self = *((NodePoint**) data);
	_node_point_free0_ (self);
}

static gpointer
_node_point_dup0 (gpointer self)
{
	return self ? node_point_dup (self) : NULL;
}

gboolean
node_group_is_within (NodeGroup* self,
                      gdouble x,
                      gdouble y)
{
	NodePoint cursor = {0};
	GArray* points = NULL;
	GArray* _tmp0_;
	GArray* hull = NULL;
	GArray* _tmp1_;
	GArray* _tmp2_;
	NodePoint _tmp3_;
	NodePoint* _tmp4_;
	GArray* _tmp13_;
	GArray* _tmp14_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	node_point_init (&cursor, x, y);
	_tmp0_ = g_array_new (TRUE, TRUE, sizeof (NodePoint*));
	g_array_set_clear_func (_tmp0_, (GDestroyNotify) _vala_NodePoint_free_function_content_of);
	points = _tmp0_;
	_tmp1_ = g_array_new (TRUE, TRUE, sizeof (NodePoint*));
	g_array_set_clear_func (_tmp1_, (GDestroyNotify) _vala_NodePoint_free_function_content_of);
	hull = _tmp1_;
	_tmp2_ = points;
	_tmp3_ = cursor;
	_tmp4_ = _node_point_dup0 (&_tmp3_);
	g_array_append_val (_tmp2_, _tmp4_);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				GArray* _tmp7_;
				GArray* _tmp8_;
				Node* _tmp9_;
				GArray* _tmp10_;
				Node* _tmp11_;
				GArray* _tmp12_;
				if (!_tmp5_) {
					gint _tmp6_;
					_tmp6_ = i;
					i = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				_tmp7_ = self->priv->_nodes;
				if (!(((guint) i) < _tmp7_->len)) {
					break;
				}
				_tmp8_ = self->priv->_nodes;
				_tmp9_ = g_array_index (_tmp8_, Node*, (guint) i);
				_tmp10_ = self->priv->_nodes;
				_tmp11_ = g_array_index (_tmp10_, Node*, (guint) i);
				_tmp12_ = points;
				node_group_get_tree_points (_tmp9_, _tmp11_, _tmp12_);
			}
		}
	}
	_tmp13_ = points;
	_tmp14_ = hull;
	node_group_get_convex_hull (_tmp13_, _tmp14_);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp15_ = FALSE;
			_tmp15_ = TRUE;
			while (TRUE) {
				GArray* _tmp17_;
				gboolean _tmp18_ = FALSE;
				NodePoint _tmp19_;
				GArray* _tmp20_;
				if (!_tmp15_) {
					gint _tmp16_;
					_tmp16_ = i;
					i = _tmp16_ + 1;
				}
				_tmp15_ = FALSE;
				_tmp17_ = hull;
				if (!(((guint) i) < _tmp17_->len)) {
					break;
				}
				_tmp19_ = cursor;
				_tmp20_ = hull;
				if (_tmp19_.x == (*g_array_index (_tmp20_, NodePoint*, (guint) i)).x) {
					NodePoint _tmp21_;
					GArray* _tmp22_;
					_tmp21_ = cursor;
					_tmp22_ = hull;
					_tmp18_ = _tmp21_.y == (*g_array_index (_tmp22_, NodePoint*, (guint) i)).y;
				} else {
					_tmp18_ = FALSE;
				}
				if (_tmp18_) {
					result = FALSE;
					_g_array_unref0 (hull);
					_g_array_unref0 (points);
					return result;
				}
			}
		}
	}
	result = TRUE;
	_g_array_unref0 (hull);
	_g_array_unref0 (points);
	return result;
}

xmlNode*
node_group_save (NodeGroup* self)
{
	xmlNode* g = NULL;
	xmlNode* _tmp0_;
	xmlNode* _tmp1_;
	GdkRGBA _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	xmlNode* _tmp16_;
	xmlNode* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = xmlNewNode (NULL, (xmlChar*) "group");
	g = _tmp0_;
	_tmp1_ = g;
	_tmp2_ = self->priv->_color;
	_tmp3_ = utils_color_from_rgba (&_tmp2_);
	_tmp4_ = _tmp3_;
	xmlSetProp (_tmp1_, (xmlChar*) "color", (xmlChar*) _tmp4_);
	_g_free0 (_tmp4_);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				GArray* _tmp7_;
				xmlNode* n = NULL;
				xmlNode* _tmp8_;
				xmlNode* _tmp9_;
				GArray* _tmp10_;
				Node* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				xmlNode* _tmp14_;
				xmlNode* _tmp15_;
				if (!_tmp5_) {
					gint _tmp6_;
					_tmp6_ = i;
					i = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				_tmp7_ = self->priv->_nodes;
				if (!(((guint) i) < _tmp7_->len)) {
					break;
				}
				_tmp8_ = xmlNewNode (NULL, (xmlChar*) "node");
				n = _tmp8_;
				_tmp9_ = n;
				_tmp10_ = self->priv->_nodes;
				_tmp11_ = g_array_index (_tmp10_, Node*, (guint) i);
				_tmp12_ = g_strdup_printf ("%i", node_id (_tmp11_));
				_tmp13_ = _tmp12_;
				xmlSetProp (_tmp9_, (xmlChar*) "id", (xmlChar*) _tmp13_);
				_g_free0 (_tmp13_);
				_tmp14_ = g;
				_tmp15_ = n;
				xmlAddChild (_tmp14_, _tmp15_);
			}
		}
	}
	_tmp16_ = g;
	result = _tmp16_;
	return result;
}

void
node_group_load (NodeGroup* self,
                 DrawArea* da,
                 xmlNode* g,
                 GeeHashMap* id_map)
{
	gchar* c = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (da != NULL);
	g_return_if_fail (id_map != NULL);
	_tmp0_ = (gchar*) xmlGetProp (g, (xmlChar*) "color");
	c = _tmp0_;
	_tmp1_ = c;
	if (_tmp1_ != NULL) {
		GdkRGBA clr = {0};
		GdkRGBA _tmp2_ = {0};
		const gchar* _tmp3_;
		GdkRGBA _tmp4_;
		_tmp2_.red = 1.0;
		_tmp2_.green = 1.0;
		_tmp2_.blue = 1.0;
		_tmp2_.alpha = 1.0;
		clr = _tmp2_;
		_tmp3_ = c;
		gdk_rgba_parse (&clr, _tmp3_);
		_tmp4_ = clr;
		node_group_set_color (self, &_tmp4_);
	}
	{
		xmlNode* it = NULL;
		xmlNode* _tmp5_;
		_tmp5_ = g->children;
		it = _tmp5_;
		{
			gboolean _tmp6_ = FALSE;
			_tmp6_ = TRUE;
			while (TRUE) {
				xmlNode* _tmp9_;
				gboolean _tmp10_ = FALSE;
				xmlNode* _tmp11_;
				xmlElementType _tmp12_;
				if (!_tmp6_) {
					xmlNode* _tmp7_;
					xmlNode* _tmp8_;
					_tmp7_ = it;
					_tmp8_ = _tmp7_->next;
					it = _tmp8_;
				}
				_tmp6_ = FALSE;
				_tmp9_ = it;
				if (!(_tmp9_ != NULL)) {
					break;
				}
				_tmp11_ = it;
				_tmp12_ = _tmp11_->type;
				if (_tmp12_ == XML_ELEMENT_NODE) {
					xmlNode* _tmp13_;
					const gchar* _tmp14_;
					_tmp13_ = it;
					_tmp14_ = _tmp13_->name;
					_tmp10_ = g_strcmp0 (_tmp14_, "node") == 0;
				} else {
					_tmp10_ = FALSE;
				}
				if (_tmp10_) {
					xmlNode* _tmp15_;
					_tmp15_ = it;
					node_group_load_node (self, da, _tmp15_, id_map);
				}
			}
		}
	}
	_g_free0 (c);
}

static void
node_group_load_node (NodeGroup* self,
                      DrawArea* da,
                      xmlNode* n,
                      GeeHashMap* id_map)
{
	gchar* i = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (da != NULL);
	g_return_if_fail (id_map != NULL);
	_tmp0_ = (gchar*) xmlGetProp (n, (xmlChar*) "id");
	i = _tmp0_;
	_tmp1_ = i;
	if (_tmp1_ != NULL) {
		gint id = 0;
		const gchar* _tmp2_;
		gpointer _tmp3_;
		Node* node = NULL;
		GArray* _tmp4_;
		GArray* _tmp5_;
		Node* _tmp6_;
		Node* _tmp7_;
		Node* _tmp8_;
		_tmp2_ = i;
		_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) id_map, (gpointer) ((gintptr) atoi (_tmp2_)));
		id = (gint) ((gintptr) _tmp3_);
		_tmp4_ = draw_area_get_nodes (da);
		_tmp5_ = _tmp4_;
		_tmp6_ = draw_area_get_node (da, _tmp5_, id);
		_tmp7_ = _tmp6_;
		_g_array_unref0 (_tmp5_);
		node = _tmp7_;
		_tmp8_ = node;
		if (_tmp8_ != NULL) {
			Node* _tmp9_;
			GArray* _tmp10_;
			Node* _tmp11_;
			Node* _tmp12_;
			_tmp9_ = node;
			node_set_group (_tmp9_, TRUE);
			_tmp10_ = self->priv->_nodes;
			_tmp11_ = node;
			_tmp12_ = _g_object_ref0 (_tmp11_);
			g_array_append_val (_tmp10_, _tmp12_);
		}
		_g_object_unref0 (node);
	}
	_g_free0 (i);
}

static void
_vala_GdkRGBA_free (GdkRGBA* self)
{
	g_boxed_free (gdk_rgba_get_type (), self);
}

static GdkRGBA*
_vala_GdkRGBA_copy (GdkRGBA* self)
{
	return g_boxed_copy (gdk_rgba_get_type (), self);
}

static gpointer
__vala_GdkRGBA_copy0 (gpointer self)
{
	return self ? _vala_GdkRGBA_copy (self) : NULL;
}

void
node_group_draw (NodeGroup* self,
                 cairo_t* ctx,
                 Theme* theme)
{
	GArray* points = NULL;
	GArray* _tmp0_;
	gboolean selected = FALSE;
	GroupMode _tmp1_;
	gdouble alpha = 0.0;
	GdkRGBA* _tmp19_ = NULL;
	GArray* _tmp23_;
	GdkRGBA _tmp24_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (ctx != NULL);
	g_return_if_fail (theme != NULL);
	_tmp0_ = g_array_new (TRUE, TRUE, sizeof (NodePoint*));
	g_array_set_clear_func (_tmp0_, (GDestroyNotify) _vala_NodePoint_free_function_content_of);
	points = _tmp0_;
	_tmp1_ = self->priv->_mode;
	selected = _tmp1_ == GROUP_MODE_SELECTED;
	alpha = 0.0;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				GArray* _tmp4_;
				GArray* _tmp5_;
				Node* _tmp6_;
				GArray* _tmp7_;
				Node* _tmp8_;
				GArray* _tmp9_;
				gdouble _tmp10_ = 0.0;
				GArray* _tmp11_;
				Node* _tmp12_;
				gdouble _tmp13_;
				gdouble _tmp14_;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = i;
					i = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				_tmp4_ = self->priv->_nodes;
				if (!(((guint) i) < _tmp4_->len)) {
					break;
				}
				_tmp5_ = self->priv->_nodes;
				_tmp6_ = g_array_index (_tmp5_, Node*, (guint) i);
				_tmp7_ = self->priv->_nodes;
				_tmp8_ = g_array_index (_tmp7_, Node*, (guint) i);
				_tmp9_ = points;
				node_group_get_tree_points (_tmp6_, _tmp8_, _tmp9_);
				_tmp11_ = self->priv->_nodes;
				_tmp12_ = g_array_index (_tmp11_, Node*, (guint) i);
				_tmp13_ = node_get_alpha (_tmp12_);
				_tmp14_ = _tmp13_;
				if (_tmp14_ > alpha) {
					GArray* _tmp15_;
					Node* _tmp16_;
					gdouble _tmp17_;
					gdouble _tmp18_;
					_tmp15_ = self->priv->_nodes;
					_tmp16_ = g_array_index (_tmp15_, Node*, (guint) i);
					_tmp17_ = node_get_alpha (_tmp16_);
					_tmp18_ = _tmp17_;
					_tmp10_ = _tmp18_;
				} else {
					_tmp10_ = alpha;
				}
				alpha = _tmp10_;
			}
		}
	}
	if (selected) {
		GdkRGBA* _tmp20_;
		_tmp20_ = theme_get_color (theme, "nodesel_background");
		__vala_GdkRGBA_free0 (_tmp19_);
		_tmp19_ = _tmp20_;
	} else {
		GdkRGBA _tmp21_;
		GdkRGBA* _tmp22_;
		_tmp21_ = self->priv->_color;
		_tmp22_ = __vala_GdkRGBA_copy0 (&_tmp21_);
		__vala_GdkRGBA_free0 (_tmp19_);
		_tmp19_ = _tmp22_;
	}
	_tmp23_ = points;
	_tmp24_ = *_tmp19_;
	node_group_draw_cloud (ctx, &_tmp24_, selected, alpha, _tmp23_);
	__vala_GdkRGBA_free0 (_tmp19_);
	_g_array_unref0 (points);
}

void
node_group_draw_tree (cairo_t* ctx,
                      Node* node,
                      Theme* theme)
{
	GArray* points = NULL;
	GArray* _tmp0_;
	GdkRGBA _tmp1_ = {0};
	GdkRGBA _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	g_return_if_fail (ctx != NULL);
	g_return_if_fail (node != NULL);
	g_return_if_fail (theme != NULL);
	_tmp0_ = g_array_new (TRUE, TRUE, sizeof (NodePoint*));
	g_array_set_clear_func (_tmp0_, (GDestroyNotify) _vala_NodePoint_free_function_content_of);
	points = _tmp0_;
	node_group_get_tree_points (node, node, points);
	node_get_link_color (node, &_tmp1_);
	_tmp2_ = _tmp1_;
	_tmp3_ = node_get_alpha (node);
	_tmp4_ = _tmp3_;
	node_group_draw_cloud (ctx, &_tmp2_, FALSE, _tmp4_, points);
	_g_array_unref0 (points);
}

static void
node_group_draw_cloud (cairo_t* ctx,
                       GdkRGBA* color,
                       gboolean selected,
                       gdouble alpha,
                       GArray* points)
{
	GArray* hull = NULL;
	GArray* _tmp0_;
	GArray* _tmp1_;
	GArray* _tmp2_;
	GdkRGBA _tmp3_;
	GArray* _tmp4_;
	GArray* _tmp5_;
	g_return_if_fail (ctx != NULL);
	g_return_if_fail (color != NULL);
	g_return_if_fail (points != NULL);
	_tmp0_ = g_array_new (TRUE, TRUE, sizeof (NodePoint*));
	g_array_set_clear_func (_tmp0_, (GDestroyNotify) _vala_NodePoint_free_function_content_of);
	hull = _tmp0_;
	_tmp1_ = hull;
	node_group_get_convex_hull (points, _tmp1_);
	_tmp2_ = hull;
	if (_tmp2_->len == ((guint) 0)) {
		_g_array_unref0 (hull);
		return;
	}
	_tmp3_ = *color;
	utils_set_context_color_with_alpha (ctx, &_tmp3_, alpha * 0.3);
	_tmp4_ = hull;
	_tmp5_ = hull;
	cairo_move_to (ctx, (*g_array_index (_tmp4_, NodePoint*, (guint) 0)).x, (*g_array_index (_tmp5_, NodePoint*, (guint) 0)).y);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp6_ = FALSE;
			_tmp6_ = TRUE;
			while (TRUE) {
				GArray* _tmp8_;
				GArray* _tmp9_;
				GArray* _tmp10_;
				if (!_tmp6_) {
					gint _tmp7_;
					_tmp7_ = i;
					i = _tmp7_ + 1;
				}
				_tmp6_ = FALSE;
				_tmp8_ = hull;
				if (!(((guint) i) < _tmp8_->len)) {
					break;
				}
				_tmp9_ = hull;
				_tmp10_ = hull;
				cairo_line_to (ctx, (*g_array_index (_tmp9_, NodePoint*, (guint) i)).x, (*g_array_index (_tmp10_, NodePoint*, (guint) i)).y);
			}
		}
	}
	cairo_close_path (ctx);
	if (selected) {
		GdkRGBA _tmp11_;
		cairo_fill_preserve (ctx);
		_tmp11_ = *color;
		utils_set_context_color_with_alpha (ctx, &_tmp11_, alpha);
		cairo_stroke (ctx);
	} else {
		cairo_fill (ctx);
	}
	_g_array_unref0 (hull);
}

void
node_group_add_node_points (GArray* points,
                            Node* node,
                            gint pad)
{
	gdouble x1 = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble y1 = 0.0;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble x2 = 0.0;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble y2 = 0.0;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp13_;
	NodePoint _tmp20_ = {0};
	NodePoint* _tmp21_;
	NodePoint _tmp22_ = {0};
	NodePoint* _tmp23_;
	NodePoint _tmp24_ = {0};
	NodePoint* _tmp25_;
	NodePoint _tmp26_ = {0};
	NodePoint* _tmp27_;
	g_return_if_fail (points != NULL);
	g_return_if_fail (node != NULL);
	_tmp0_ = node_get_posx (node);
	_tmp1_ = _tmp0_;
	x1 = _tmp1_ - pad;
	_tmp2_ = node_get_posy (node);
	_tmp3_ = _tmp2_;
	y1 = _tmp3_ - pad;
	_tmp4_ = node_get_posx (node);
	_tmp5_ = _tmp4_;
	_tmp6_ = node_get_width (node);
	_tmp7_ = _tmp6_;
	x2 = (_tmp5_ + _tmp7_) + pad;
	_tmp8_ = node_get_posy (node);
	_tmp9_ = _tmp8_;
	_tmp10_ = node_get_height (node);
	_tmp11_ = _tmp10_;
	y2 = (_tmp9_ + _tmp11_) + pad;
	_tmp12_ = node_get_folded (node);
	_tmp13_ = _tmp12_;
	if (_tmp13_) {
		gdouble fx = 0.0;
		gdouble fy = 0.0;
		gdouble fw = 0.0;
		gdouble fh = 0.0;
		gdouble _tmp14_ = 0.0;
		gdouble _tmp15_ = 0.0;
		gdouble _tmp16_ = 0.0;
		gdouble _tmp17_ = 0.0;
		NodeSide _tmp18_;
		NodeSide _tmp19_;
		node_fold_bbox (node, &_tmp14_, &_tmp15_, &_tmp16_, &_tmp17_);
		fx = _tmp14_;
		fy = _tmp15_;
		fw = _tmp16_;
		fh = _tmp17_;
		_tmp18_ = node_get_side (node);
		_tmp19_ = _tmp18_;
		switch (_tmp19_) {
			case NODE_SIDE_LEFT:
			{
				x1 = fx - pad;
				break;
			}
			case NODE_SIDE_RIGHT:
			{
				x2 = (fx + fw) + pad;
				break;
			}
			case NODE_SIDE_TOP:
			{
				y1 = fy - pad;
				break;
			}
			case NODE_SIDE_BOTTOM:
			{
				y2 = (fy + fh) + pad;
				break;
			}
			default:
			break;
		}
	}
	node_point_init (&_tmp20_, x1, y1);
	_tmp21_ = _node_point_dup0 (&_tmp20_);
	g_array_append_val (points, _tmp21_);
	node_point_init (&_tmp22_, x2, y1);
	_tmp23_ = _node_point_dup0 (&_tmp22_);
	g_array_append_val (points, _tmp23_);
	node_point_init (&_tmp24_, x1, y2);
	_tmp25_ = _node_point_dup0 (&_tmp24_);
	g_array_append_val (points, _tmp25_);
	node_point_init (&_tmp26_, x2, y2);
	_tmp27_ = _node_point_dup0 (&_tmp26_);
	g_array_append_val (points, _tmp27_);
}

void
node_group_get_tree_points (Node* origin,
                            Node* node,
                            GArray* points)
{
	Node* _tmp0_;
	Node* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (origin != NULL);
	g_return_if_fail (node != NULL);
	g_return_if_fail (points != NULL);
	_tmp0_ = node_folded_ancestor (node);
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_ == NULL;
	_g_object_unref0 (_tmp1_);
	if (_tmp2_) {
		gint pad = 0;
		pad = node_groups_between (node, origin) * 5;
		node_group_add_node_points (points, node, pad);
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp3_ = FALSE;
				_tmp3_ = TRUE;
				while (TRUE) {
					GArray* _tmp5_;
					GArray* _tmp6_;
					gboolean _tmp7_;
					GArray* _tmp8_;
					GArray* _tmp9_;
					Node* _tmp10_;
					if (!_tmp3_) {
						gint _tmp4_;
						_tmp4_ = i;
						i = _tmp4_ + 1;
					}
					_tmp3_ = FALSE;
					_tmp5_ = node_children (node);
					_tmp6_ = _tmp5_;
					_tmp7_ = !(((guint) i) < _tmp6_->len);
					_g_array_unref0 (_tmp6_);
					if (_tmp7_) {
						break;
					}
					_tmp8_ = node_children (node);
					_tmp9_ = _tmp8_;
					_tmp10_ = g_array_index (_tmp9_, Node*, (guint) i);
					node_group_get_tree_points (origin, _tmp10_, points);
					_g_array_unref0 (_tmp9_);
				}
			}
		}
	}
}

void
node_group_get_convex_hull (GArray* points,
                            GArray* hull)
{
	gint n = 0;
	gint l = 0;
	gint p = 0;
	g_return_if_fail (points != NULL);
	g_return_if_fail (hull != NULL);
	n = (gint) points->len;
	if (n == 0) {
		return;
	}
	l = 0;
	{
		gint i = 0;
		i = 1;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < n)) {
					break;
				}
				if ((*g_array_index (points, NodePoint*, (guint) i)).x < (*g_array_index (points, NodePoint*, (guint) l)).x) {
					l = i;
				}
			}
		}
	}
	p = l;
	{
		gboolean _tmp2_ = FALSE;
		_tmp2_ = TRUE;
		while (TRUE) {
			NodePoint* _tmp3_;
			gint q = 0;
			if (!_tmp2_) {
				if (!(p != l)) {
					break;
				}
			}
			_tmp2_ = FALSE;
			_tmp3_ = _node_point_dup0 (g_array_index (points, NodePoint*, (guint) p));
			g_array_append_val (hull, _tmp3_);
			q = (p + 1) % n;
			{
				gint i = 0;
				i = 0;
				{
					gboolean _tmp4_ = FALSE;
					_tmp4_ = TRUE;
					while (TRUE) {
						NodePoint _tmp6_;
						NodePoint _tmp7_;
						NodePoint _tmp8_;
						if (!_tmp4_) {
							gint _tmp5_;
							_tmp5_ = i;
							i = _tmp5_ + 1;
						}
						_tmp4_ = FALSE;
						if (!(i < n)) {
							break;
						}
						_tmp6_ = *g_array_index (points, NodePoint*, (guint) p);
						_tmp7_ = *g_array_index (points, NodePoint*, (guint) i);
						_tmp8_ = *g_array_index (points, NodePoint*, (guint) q);
						if (node_group_calc_orientation (&_tmp6_, &_tmp7_, &_tmp8_) == 2) {
							q = i;
						}
					}
				}
			}
			p = q;
		}
	}
}

gint
node_group_calc_orientation (NodePoint* p,
                             NodePoint* q,
                             NodePoint* r)
{
	gdouble val = 0.0;
	NodePoint _tmp0_;
	NodePoint _tmp1_;
	NodePoint _tmp2_;
	NodePoint _tmp3_;
	NodePoint _tmp4_;
	NodePoint _tmp5_;
	NodePoint _tmp6_;
	NodePoint _tmp7_;
	gint _tmp8_ = 0;
	gint result = 0;
	g_return_val_if_fail (p != NULL, 0);
	g_return_val_if_fail (q != NULL, 0);
	g_return_val_if_fail (r != NULL, 0);
	_tmp0_ = *q;
	_tmp1_ = *p;
	_tmp2_ = *r;
	_tmp3_ = *q;
	_tmp4_ = *q;
	_tmp5_ = *p;
	_tmp6_ = *r;
	_tmp7_ = *q;
	val = ((_tmp0_.y - _tmp1_.y) * (_tmp2_.x - _tmp3_.x)) - ((_tmp4_.x - _tmp5_.x) * (_tmp6_.y - _tmp7_.y));
	if (val == ((gdouble) 0)) {
		result = 0;
		return result;
	}
	if (val > ((gdouble) 0)) {
		_tmp8_ = 1;
	} else {
		_tmp8_ = 2;
	}
	result = _tmp8_;
	return result;
}

GroupMode
node_group_get_mode (NodeGroup* self)
{
	GroupMode result;
	GroupMode _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_mode;
	result = _tmp0_;
	return result;
}

void
node_group_set_mode (NodeGroup* self,
                     GroupMode value)
{
	g_return_if_fail (self != NULL);
	self->priv->_mode = value;
}

void
node_group_get_color (NodeGroup* self,
                      GdkRGBA * result)
{
	GdkRGBA _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_color;
	*result = _tmp0_;
	return;
}

void
node_group_set_color (NodeGroup* self,
                      GdkRGBA * value)
{
	GdkRGBA _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = *value;
	self->priv->_color = _tmp0_;
}

GArray*
node_group_get_nodes (NodeGroup* self)
{
	GArray* result;
	GArray* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_nodes;
	result = _tmp0_;
	return result;
}

static void
value_node_group_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
value_node_group_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		node_group_unref (value->data[0].v_pointer);
	}
}

static void
value_node_group_copy_value (const GValue* src_value,
                             GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = node_group_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
value_node_group_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
value_node_group_collect_value (GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		NodeGroup * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = node_group_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
value_node_group_lcopy_value (const GValue* value,
                              guint n_collect_values,
                              GTypeCValue* collect_values,
                              guint collect_flags)
{
	NodeGroup ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = node_group_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
param_spec_node_group (const gchar* name,
                       const gchar* nick,
                       const gchar* blurb,
                       GType object_type,
                       GParamFlags flags)
{
	ParamSpecNodeGroup* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_NODE_GROUP), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
value_get_node_group (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_NODE_GROUP), NULL);
	return value->data[0].v_pointer;
}

void
value_set_node_group (GValue* value,
                      gpointer v_object)
{
	NodeGroup * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_NODE_GROUP));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_NODE_GROUP));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		node_group_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		node_group_unref (old);
	}
}

void
value_take_node_group (GValue* value,
                       gpointer v_object)
{
	NodeGroup * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_NODE_GROUP));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_NODE_GROUP));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		node_group_unref (old);
	}
}

static void
node_group_class_init (NodeGroupClass * klass,
                       gpointer klass_data)
{
	node_group_parent_class = g_type_class_peek_parent (klass);
	((NodeGroupClass *) klass)->finalize = node_group_finalize;
	g_type_class_adjust_private_offset (klass, &NodeGroup_private_offset);
}

static void
node_group_instance_init (NodeGroup * self,
                          gpointer klass)
{
	self->priv = node_group_get_instance_private (self);
	self->priv->_mode = GROUP_MODE_NONE;
	self->ref_count = 1;
}

static void
node_group_finalize (NodeGroup * obj)
{
	NodeGroup * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NODE_GROUP, NodeGroup);
	g_signal_handlers_destroy (self);
	_g_array_unref0 (self->priv->_nodes);
}

static GType
node_group_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_node_group_init, value_node_group_free_value, value_node_group_copy_value, value_node_group_peek_pointer, "p", value_node_group_collect_value, "p", value_node_group_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (NodeGroupClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) node_group_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NodeGroup), 0, (GInstanceInitFunc) node_group_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType node_group_type_id;
	node_group_type_id = g_type_register_fundamental (g_type_fundamental_next (), "NodeGroup", &g_define_type_info, &g_define_type_fundamental_info, 0);
	NodeGroup_private_offset = g_type_add_instance_private (node_group_type_id, sizeof (NodeGroupPrivate));
	return node_group_type_id;
}

GType
node_group_get_type (void)
{
	static volatile gsize node_group_type_id__volatile = 0;
	if (g_once_init_enter (&node_group_type_id__volatile)) {
		GType node_group_type_id;
		node_group_type_id = node_group_get_type_once ();
		g_once_init_leave (&node_group_type_id__volatile, node_group_type_id);
	}
	return node_group_type_id__volatile;
}

gpointer
node_group_ref (gpointer instance)
{
	NodeGroup * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
node_group_unref (gpointer instance)
{
	NodeGroup * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		NODE_GROUP_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

