/* UndoItem.c generated by valac 0.48.13, the Vala compiler
 * generated from UndoItem.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#define TYPE_UNDO_ITEM (undo_item_get_type ())
#define UNDO_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UNDO_ITEM, UndoItem))
#define UNDO_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UNDO_ITEM, UndoItemClass))
#define IS_UNDO_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UNDO_ITEM))
#define IS_UNDO_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UNDO_ITEM))
#define UNDO_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UNDO_ITEM, UndoItemClass))

typedef struct _UndoItem UndoItem;
typedef struct _UndoItemClass UndoItemClass;
typedef struct _UndoItemPrivate UndoItemPrivate;

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;
enum  {
	UNDO_ITEM_0_PROPERTY,
	UNDO_ITEM_NAME_PROPERTY,
	UNDO_ITEM_ID_PROPERTY,
	UNDO_ITEM_NUM_PROPERTIES
};
static GParamSpec* undo_item_properties[UNDO_ITEM_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _UndoItem {
	GObject parent_instance;
	UndoItemPrivate * priv;
};

struct _UndoItemClass {
	GObjectClass parent_class;
	void (*undo) (UndoItem* self, DrawArea* da);
	void (*redo) (UndoItem* self, DrawArea* da);
	gboolean (*matches) (UndoItem* self, UndoItem* item);
	void (*replace_with_item) (UndoItem* self, UndoItem* item);
	gchar* (*to_string) (UndoItem* self);
};

struct _UndoItemPrivate {
	gchar* _name;
	gint _id;
};

static gint UndoItem_private_offset;
static gpointer undo_item_parent_class = NULL;

GType undo_item_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UndoItem, g_object_unref)
GType draw_area_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DrawArea, g_object_unref)
void undo_item_undo (UndoItem* self,
                     DrawArea* da);
void undo_item_redo (UndoItem* self,
                     DrawArea* da);
gboolean undo_item_matches (UndoItem* self,
                            UndoItem* item);
void undo_item_replace_with_item (UndoItem* self,
                                  UndoItem* item);
gchar* undo_item_to_string (UndoItem* self);
UndoItem* undo_item_new (const gchar* name);
UndoItem* undo_item_construct (GType object_type,
                               const gchar* name);
void undo_item_set_name (UndoItem* self,
                         const gchar* value);
static void undo_item_real_undo (UndoItem* self,
                          DrawArea* da);
static void undo_item_real_redo (UndoItem* self,
                          DrawArea* da);
static gboolean undo_item_real_matches (UndoItem* self,
                                 UndoItem* item);
static void undo_item_real_replace_with_item (UndoItem* self,
                                       UndoItem* item);
static gchar* undo_item_real_to_string (UndoItem* self);
const gchar* undo_item_get_name (UndoItem* self);
gint undo_item_get_id (UndoItem* self);
void undo_item_set_id (UndoItem* self,
                       gint value);
static void undo_item_finalize (GObject * obj);
static GType undo_item_get_type_once (void);
static void _vala_undo_item_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_undo_item_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);

static inline gpointer
undo_item_get_instance_private (UndoItem* self)
{
	return G_STRUCT_MEMBER_P (self, UndoItem_private_offset);
}

UndoItem*
undo_item_construct (GType object_type,
                     const gchar* name)
{
	UndoItem * self = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	self = (UndoItem*) g_object_new (object_type, NULL);
	undo_item_set_name (self, name);
	return self;
}

UndoItem*
undo_item_new (const gchar* name)
{
	return undo_item_construct (TYPE_UNDO_ITEM, name);
}

static void
undo_item_real_undo (UndoItem* self,
                     DrawArea* da)
{
	g_return_if_fail (da != NULL);
}

void
undo_item_undo (UndoItem* self,
                DrawArea* da)
{
	g_return_if_fail (self != NULL);
	UNDO_ITEM_GET_CLASS (self)->undo (self, da);
}

static void
undo_item_real_redo (UndoItem* self,
                     DrawArea* da)
{
	g_return_if_fail (da != NULL);
}

void
undo_item_redo (UndoItem* self,
                DrawArea* da)
{
	g_return_if_fail (self != NULL);
	UNDO_ITEM_GET_CLASS (self)->redo (self, da);
}

static gboolean
undo_item_real_matches (UndoItem* self,
                        UndoItem* item)
{
	gboolean result = FALSE;
	g_return_val_if_fail (item != NULL, FALSE);
	result = FALSE;
	return result;
}

gboolean
undo_item_matches (UndoItem* self,
                   UndoItem* item)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return UNDO_ITEM_GET_CLASS (self)->matches (self, item);
}

static void
undo_item_real_replace_with_item (UndoItem* self,
                                  UndoItem* item)
{
	g_return_if_fail (item != NULL);
}

void
undo_item_replace_with_item (UndoItem* self,
                             UndoItem* item)
{
	g_return_if_fail (self != NULL);
	UNDO_ITEM_GET_CLASS (self)->replace_with_item (self, item);
}

static gchar*
undo_item_real_to_string (UndoItem* self)
{
	const gchar* _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_;
	gchar* result = NULL;
	_tmp0_ = self->priv->_name;
	_tmp1_ = self->priv->_id;
	_tmp2_ = g_strdup_printf ("%s [%d]", _tmp0_, _tmp1_);
	result = _tmp2_;
	return result;
}

gchar*
undo_item_to_string (UndoItem* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return UNDO_ITEM_GET_CLASS (self)->to_string (self);
}

const gchar*
undo_item_get_name (UndoItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}

void
undo_item_set_name (UndoItem* self,
                    const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = undo_item_get_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_name);
		self->priv->_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, undo_item_properties[UNDO_ITEM_NAME_PROPERTY]);
	}
}

gint
undo_item_get_id (UndoItem* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_id;
	return result;
}

void
undo_item_set_id (UndoItem* self,
                  gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = undo_item_get_id (self);
	if (old_value != value) {
		self->priv->_id = value;
		g_object_notify_by_pspec ((GObject *) self, undo_item_properties[UNDO_ITEM_ID_PROPERTY]);
	}
}

static void
undo_item_class_init (UndoItemClass * klass,
                      gpointer klass_data)
{
	undo_item_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &UndoItem_private_offset);
	((UndoItemClass *) klass)->undo = (void (*) (UndoItem*, DrawArea*)) undo_item_real_undo;
	((UndoItemClass *) klass)->redo = (void (*) (UndoItem*, DrawArea*)) undo_item_real_redo;
	((UndoItemClass *) klass)->matches = (gboolean (*) (UndoItem*, UndoItem*)) undo_item_real_matches;
	((UndoItemClass *) klass)->replace_with_item = (void (*) (UndoItem*, UndoItem*)) undo_item_real_replace_with_item;
	((UndoItemClass *) klass)->to_string = (gchar* (*) (UndoItem*)) undo_item_real_to_string;
	G_OBJECT_CLASS (klass)->get_property = _vala_undo_item_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_undo_item_set_property;
	G_OBJECT_CLASS (klass)->finalize = undo_item_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), UNDO_ITEM_NAME_PROPERTY, undo_item_properties[UNDO_ITEM_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), UNDO_ITEM_ID_PROPERTY, undo_item_properties[UNDO_ITEM_ID_PROPERTY] = g_param_spec_int ("id", "id", "id", G_MININT, G_MAXINT, -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
undo_item_instance_init (UndoItem * self,
                         gpointer klass)
{
	gchar* _tmp0_;
	self->priv = undo_item_get_instance_private (self);
	_tmp0_ = g_strdup ("");
	self->priv->_name = _tmp0_;
	self->priv->_id = -1;
}

static void
undo_item_finalize (GObject * obj)
{
	UndoItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_UNDO_ITEM, UndoItem);
	_g_free0 (self->priv->_name);
	G_OBJECT_CLASS (undo_item_parent_class)->finalize (obj);
}

static GType
undo_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UndoItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) undo_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UndoItem), 0, (GInstanceInitFunc) undo_item_instance_init, NULL };
	GType undo_item_type_id;
	undo_item_type_id = g_type_register_static (G_TYPE_OBJECT, "UndoItem", &g_define_type_info, 0);
	UndoItem_private_offset = g_type_add_instance_private (undo_item_type_id, sizeof (UndoItemPrivate));
	return undo_item_type_id;
}

GType
undo_item_get_type (void)
{
	static volatile gsize undo_item_type_id__volatile = 0;
	if (g_once_init_enter (&undo_item_type_id__volatile)) {
		GType undo_item_type_id;
		undo_item_type_id = undo_item_get_type_once ();
		g_once_init_leave (&undo_item_type_id__volatile, undo_item_type_id);
	}
	return undo_item_type_id__volatile;
}

static void
_vala_undo_item_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	UndoItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_UNDO_ITEM, UndoItem);
	switch (property_id) {
		case UNDO_ITEM_NAME_PROPERTY:
		g_value_set_string (value, undo_item_get_name (self));
		break;
		case UNDO_ITEM_ID_PROPERTY:
		g_value_set_int (value, undo_item_get_id (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_undo_item_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	UndoItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_UNDO_ITEM, UndoItem);
	switch (property_id) {
		case UNDO_ITEM_NAME_PROPERTY:
		undo_item_set_name (self, g_value_get_string (value));
		break;
		case UNDO_ITEM_ID_PROPERTY:
		undo_item_set_id (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

